/*  This file is part of FreeDoko.
    FreeDoko is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version (see <http://www.gnu.org/licenses/>).

    Diese Datei ist Teil von FreeDoko.
    FreeDoko ist Freie Software: Sie können es unter den Bedingungen der GNU General Public License, wie von der Free Software Foundation, Version 3 der Lizenz oder (nach Ihrer Wahl) jeder neueren veröffentlichten Version, weiter verteilen und/oder modifizieren (siehe <https://www.gnu.org/licenses/>).
    */

#ifdef USE_UI_GTKMM

#pragma once

#include "constants.h"

#include "base.h"
#include "widgets/sticky_dialog.h"
namespace Gtk {
class TextView;
class Button;
} // namespace Gtk

namespace UI_GTKMM_NS {

/**
 ** the license dialog
 **/
class License : public Base, public Gtk::StickyDialog {
  public:
    explicit License(Base* parent);
    ~License() override;

  private:
    void init();

  public:
    void license_update(); 

  private:
    Gtk::TextView* program_text = nullptr;
    Gtk::TextView* cardset_text = nullptr;
    Gtk::TextView* iconset_text = nullptr;

  private: // unused
    License() = delete;
    License(License const&) = delete;
    License& operator=(License const&) = delete;
}; // class License : public Base, public Gtk::StickyDialog

} // namespace UI_GTKMM_NS

#endif // #ifdef USE_UI_GTKMM
